<template>
  <!-- 导入表 -->
  <el-dialog v-model="visible" title="导入表" width="800px" top="5vh" append-to-body>
    <el-form ref="queryRef" :model="queryParams" :inline="true">
      <el-form-item label="表名称" prop="tableName">
        <el-input v-model="queryParams.tableName" clearable placeholder="请输入表名称" @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="表描述" prop="tableComment">
        <el-input v-model="queryParams.tableComment" clearable placeholder="请输入表描述" @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-table ref="table" :data="dbTableList" height="260px" @row-click="clickRow" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" />
      <el-table-column prop="tableName" label="表名称" :show-overflow-tooltip="true" />
      <el-table-column prop="tableComment" label="表描述" :show-overflow-tooltip="true" />
      <el-table-column prop="createTime" label="创建时间" />
      <el-table-column prop="updateTime" label="更新时间" />
    </el-table>

    <pagination
      v-show="total > 0"
      v-model:page="queryParams.pageNumber"
      v-model:limit="queryParams.pageSize"
      :total="total"
      @pagination="getList"
    />

    <template #footer>
      <div class="dialog-footer">
        <el-button type="primary" :loading="loadingButton" @click="handleImportTable">确 定</el-button>
        <el-button @click="visible = false">取 消</el-button>
      </div>
    </template>
  </el-dialog>
</template>

<script setup>
import { listTables, addTable } from '@/api/tool/gen'

const total = ref(0)
const visible = ref(false)
const loadingButton = ref(false)
const tables = ref([])
const dbTableList = ref([])
const { proxy } = getCurrentInstance()

const queryParams = reactive({
  pageNumber: 1,
  pageSize: 10,
  tableName: undefined,
  tableComment: undefined
})

const emit = defineEmits(['ok'])

/** 查询参数列表 */
function show() {
  getList()
  visible.value = true
}
/** 单击选择行 */
function clickRow(row) {
  proxy.$refs.table.toggleRowSelection(row)
}
/** 多选框选中数据 */
function handleSelectionChange(selection) {
  tables.value = selection.map(item => item.tableName)
}
/** 查询表数据 */
function getList() {
  listTables(queryParams).then(res => {
    dbTableList.value = res.list
    total.value = Number(res.total)
  })
}
/** 搜索按钮操作 */
function handleQuery() {
  queryParams.pageNumber = 1
  getList()
}
/** 重置按钮操作 */
function resetQuery() {
  proxy.$resetForm('queryRef')
  handleQuery()
}
/** 导入按钮操作 */
function handleImportTable() {
  const tableNames = tables.value.join(',')
  if (tableNames === '') {
    proxy.$modal.msgError('请选择要导入的表')
    return
  }
  loadingButton.value = true
  addTable({ tables: tableNames }).then(res => {
    proxy.$modal.msgSuccess('导入成功')
    visible.value = false
    emit('ok')
  }).finally(() => {
    loadingButton.value = false
  })
}

defineExpose({
  show
})
</script>
